package goki.stats;

import goki.stats.handlers.PacketHandler;
import goki.stats.lib.Reference;
import goki.stats.stats.Stat;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.client.event.FOVUpdateEvent;
import net.minecraftforge.client.event.sound.SoundLoadEvent;
import net.minecraftforge.event.ForgeSubscribe;
import net.minecraftforge.event.entity.EntityJoinWorldEvent;
import cpw.mods.fml.common.network.PacketDispatcher;
import cpw.mods.fml.common.network.Player;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

public class Events
{
	@SideOnly(Side.CLIENT)
	@ForgeSubscribe
	public void onSound(SoundLoadEvent event)
	{
		try
		{
			String[] soundFiles =
			{ "reaper1.ogg", "reaper2.ogg", "reaper3.ogg" };
			for (int i = 0; i < soundFiles.length; i++)
			{
				event.manager.soundPoolSounds.addSound(Reference.MOD_ID + ":" + soundFiles[i]);
			}

		} catch (Exception e)
		{
			System.err.println("gokiStats: Failed to register one or more sounds.");
		}
	}

	@SideOnly(Side.CLIENT)
	@ForgeSubscribe
	public void updateFOV(FOVUpdateEvent event)
	{
		float fov = event.fov;
		if (fov > 1.15f)
		{
			fov = 1.15f;
		}
		if (event.entity.isSneaking())
		{
			fov = 0.95f;
		}
		event.newfov = fov;
	}

	@SideOnly(Side.SERVER)
	@ForgeSubscribe
	public void playerJoinServerConfigUpdate(EntityJoinWorldEvent event)
	{
		if (event.entity instanceof EntityPlayer)
		{
			EntityPlayer player = (EntityPlayer) event.entity;
			if (!player.worldObj.isRemote)
			{
				Stat.loadOptions(Reference.configuration);
				Stat.loadAllStatsFromConfiguration(Reference.configuration);
				PacketDispatcher.sendPacketToPlayer(PacketHandler.getStatConfigPacket(new Stat()), (Player) player);
			}
		}
	}

	@SideOnly(Side.CLIENT)
	@ForgeSubscribe
	public void playerJoinClientConfigUpdate(EntityJoinWorldEvent event)
	{
		if (event.entity instanceof EntityPlayer)
		{
			EntityPlayer player = (EntityPlayer) event.entity;
			if (!player.worldObj.isRemote)
			{
				Stat.loadOptions(Reference.configuration);
				Stat.loadAllStatsFromConfiguration(Reference.configuration);
				PacketDispatcher.sendPacketToPlayer(PacketHandler.getStatConfigPacket(new Stat()), (Player) player);
			}
		}
	}
}
