package goki.stats.client.gui;

import goki.stats.ToolSpecificStat;
import goki.stats.lib.Reference;
import goki.stats.stats.Stat;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.entity.player.EntityPlayer;

public class GuiCompatibilityHelper extends GuiScreen
{

	private EntityPlayer player = null;
	private final int BUTTON_WIDTH = 240;
	private final int BUTTON_HEIGHT = 15;
	private final ToolSpecificStat compatibleStats[] = new ToolSpecificStat[]
	{ Stat.STAT_MINING, Stat.STAT_DIGGING, Stat.STAT_CHOPPING, Stat.STAT_TRIMMING, Stat.STAT_SWORDSMANSHIP, Stat.STAT_BOWMANSHIP };

	public GuiCompatibilityHelper(EntityPlayer player)
	{
		this.player = player;
	}

	@SuppressWarnings("unchecked")
	@Override
	public void initGui()
	{
		int button = 0;
		int x = this.width / 2;
		int y = this.height / 2 - 6 * BUTTON_HEIGHT / 2;
		this.buttonList.add(new GuiExtendedButton(button, x - BUTTON_WIDTH / 2, y - BUTTON_HEIGHT + BUTTON_HEIGHT * button++, BUTTON_WIDTH, BUTTON_HEIGHT, "Add item to Mining list", 0x333333));
		this.buttonList.add(new GuiExtendedButton(button, x - BUTTON_WIDTH / 2, y - BUTTON_HEIGHT + BUTTON_HEIGHT * button++, BUTTON_WIDTH, BUTTON_HEIGHT, "Add item to Digging list", 0x333333));
		this.buttonList.add(new GuiExtendedButton(button, x - BUTTON_WIDTH / 2, y - BUTTON_HEIGHT + BUTTON_HEIGHT * button++, BUTTON_WIDTH, BUTTON_HEIGHT, "Add item to Chopping list", 0x333333));
		this.buttonList.add(new GuiExtendedButton(button, x - BUTTON_WIDTH / 2, y - BUTTON_HEIGHT + BUTTON_HEIGHT * button++, BUTTON_WIDTH, BUTTON_HEIGHT, "Add item to Trimming list", 0x333333));
		this.buttonList.add(new GuiExtendedButton(button, x - BUTTON_WIDTH / 2, y - BUTTON_HEIGHT + BUTTON_HEIGHT * button++, BUTTON_WIDTH, BUTTON_HEIGHT, "Add item to Swordsmanship list", 0x333333));
		this.buttonList.add(new GuiExtendedButton(button, x - BUTTON_WIDTH / 2, y - BUTTON_HEIGHT + BUTTON_HEIGHT * button++, BUTTON_WIDTH, BUTTON_HEIGHT, "Add item to Bowmanship list", 0x333333));
		checkStatus();
	}

	@Override
	public void drawScreen(int par1, int par2, float par3)
	{
		super.drawScreen(par1, par2, par3);
		drawCenteredString(mc.fontRenderer, "This is CLIENT-SIDE. Copy the config to the server and /reloadGokiStats.", this.width / 2, 16, 0xffffff);
	}

	@Override
	protected void actionPerformed(GuiButton button)
	{

		if (compatibleStats[button.id].isAffectedByStat(player.getHeldItem()) != 0)
		{
			compatibleStats[button.id].removeSupportForItem(player.getHeldItem());
		} else
		{
			compatibleStats[button.id].addSupportForItem(player.getHeldItem());
		}
		Reference.configuration.save();
		checkStatus();
	}

	public void checkStatus()
	{
		Reference.configuration.load();
		for (int i = 0; i < compatibleStats.length; i++)
		{
			if (compatibleStats[i].isAffectedByStat(player.getHeldItem()) != 0)
			{
				((GuiExtendedButton) this.buttonList.get(i)).displayString = "Remove item from " + compatibleStats[i].name + " list.";
				((GuiExtendedButton) this.buttonList.get(i)).setBackgroundColor(0x339933);
			} else
			{
				((GuiExtendedButton) this.buttonList.get(i)).displayString = "Add item to " + compatibleStats[i].name + " list.";
				((GuiExtendedButton) this.buttonList.get(i)).setBackgroundColor(0x993333);
			}
		}
	}

	@Override
	public void onGuiClosed()
	{
		Reference.configuration.save();
	}

}
