package goki.stats.client.gui;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Gui;
import net.minecraft.client.gui.GuiButton;

import org.lwjgl.opengl.GL11;

public class GuiExtendedButton extends GuiButton
{

	private int backgroundColor;
	private int borderColor = 0xFF000000;
	private boolean pressed = false;

	public GuiExtendedButton(int id, int x, int y, int width, int height, String text, int color)
	{
		super(id, x, y, width, height, text);
		backgroundColor = color;
	}

	@Override
	public void drawButton(Minecraft mc, int mouseX, int mouseY)
	{
		if (this.enabled)
		{
			if (!isUnderMouse(mouseX, mouseY))
			{
				drawIdle(mc, mouseX, mouseY);
			} else if (pressed)
			{
				drawDown(mc, mouseX, mouseY);
			} else
			{
				drawHover(mc, mouseX, mouseY);
			}
		} else
		{
			drawDisabled(mc, mouseX, mouseY);
		}
	}

	public boolean isUnderMouse(int mouseX, int mouseY)
	{
		return mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
	}

	private void drawBorder()
	{
		this.drawHorizontalLine(-1, this.width, 0, this.borderColor);
		this.drawHorizontalLine(-1, this.width, this.height, this.borderColor);
		this.drawVerticalLine(-1, 0, this.height, this.borderColor);
		this.drawVerticalLine(this.width, 0, this.height, this.borderColor);
	}

	private void drawDisabled(Minecraft mc, int mouseX, int mouseY)
	{
		GL11.glPushMatrix();
		GL11.glTranslatef(this.xPosition, this.yPosition, 0);
		Gui.drawRect(0, 0, this.width, this.height, 0x88222222);
		this.drawCenteredString(mc.fontRenderer, this.displayString, this.width / 2, this.height / 2 - mc.fontRenderer.FONT_HEIGHT / 2 + 1, 0x333333);
		drawBorder();
		GL11.glPopMatrix();
	}

	private void drawIdle(Minecraft mc, int mouseX, int mouseY)
	{
		GL11.glPushMatrix();
		GL11.glTranslatef(this.xPosition, this.yPosition, 0);
		Gui.drawRect(0, 0, this.width, this.height, this.backgroundColor + 0x88000000);
		this.drawCenteredString(mc.fontRenderer, this.displayString, this.width / 2, this.height / 2 - mc.fontRenderer.FONT_HEIGHT / 2 + 1, 0xFFFFFF);
		drawBorder();
		GL11.glPopMatrix();
	}

	private void drawHover(Minecraft mc, int mouseX, int mouseY)
	{
		GL11.glPushMatrix();
		GL11.glTranslatef(this.xPosition, this.yPosition, 0);
		Gui.drawRect(0, 0, this.width, this.height, this.backgroundColor + 0xFF000000);
		this.drawCenteredString(mc.fontRenderer, this.displayString, this.width / 2, this.height / 2 - mc.fontRenderer.FONT_HEIGHT / 2 + 1, 0xFFCC00);
		drawBorder();
		GL11.glPopMatrix();
	}

	private void drawDown(Minecraft mc, int mouseX, int mouseY)
	{
		GL11.glPushMatrix();
		GL11.glTranslatef(this.xPosition, this.yPosition, 0);
		Gui.drawRect(0, 0, this.width, this.height, 0xFF000000);
		this.drawCenteredString(mc.fontRenderer, this.displayString, this.width / 2, this.height / 2 - mc.fontRenderer.FONT_HEIGHT / 2 + 1, 0xFFCC00);
		drawBorder();
		GL11.glPopMatrix();
	}

	public void setBackgroundColor(int color)
	{
		backgroundColor = color;
	}

	public void onPressed()
	{
		pressed = true;
	}

	public void onReleased()
	{
		pressed = false;
	}

	public boolean isPressed()
	{
		return pressed;
	}

}
