package goki.stats.client.gui;

import goki.stats.lib.Helper;
import goki.stats.lib.Reference;
import goki.stats.stats.Stat;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.renderer.texture.TextureManager;
import net.minecraft.entity.player.EntityPlayer;

import org.lwjgl.opengl.GL11;

public class GuiStatButton extends GuiButton
{

	public Stat stat;
	public EntityPlayer player;

	public GuiStatButton(int id, int x, int y, int width, int height, Stat stat, EntityPlayer player)
	{
		super(id, x, y, width, height, "");
		this.stat = stat;
		this.player = player;
	}

	public void drawButton(Minecraft mc, int mouseX, int mouseY)
	{
		if (this.drawButton)
		{
			int iconu = 0;
			int iconv = GuiStats.STATUS_BUTTON_HEIGHT * (stat.imageID % GuiStats.IMAGE_ROWS);
			int level = stat.getPlayersStatLevel(player);
			int cost = stat.getCost(level);
			int playerXP = Helper.getXPTotal(player);
			String message = level + "";
			int messageColor = 0xFFFFFF;

			FontRenderer fontrenderer = mc.fontRenderer;
			GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
			this.field_82253_i = isUnderMouse(mouseX, mouseY);
			int which = this.getHoverState(this.field_82253_i);

			if (which == 2)
			{
				iconu = GuiStats.STATUS_BUTTON_WIDTH;
			}
			if (playerXP < cost)
			{
				iconu = GuiStats.STATUS_BUTTON_WIDTH * 2;
			}
			if (level >= stat.getLimit())
			{
				iconu = GuiStats.STATUS_BUTTON_WIDTH * 3;
			}
			if (!stat.enabled)
			{
				iconu = GuiStats.STATUS_BUTTON_WIDTH * 2;
				message = "X";
			}
			if (level >= stat.getLimit())
			{
				message = "*" + level + "*";
				messageColor = 0xFFCC00;
			}

			iconu += (int) (stat.imageID / GuiStats.IMAGE_ROWS) * GuiStats.STATUS_BUTTON_WIDTH * 4;

			TextureManager tex = mc.getTextureManager();
			tex.bindTexture(Reference.RPG_ICON_TEXTURE_LOCATION);
			GL11.glPushMatrix();
			GL11.glTranslatef(this.xPosition, this.yPosition, 0);
			GL11.glScalef(GuiStats.SCALE, GuiStats.SCALE, 0);
			this.drawTexturedModalRect(0, 0, iconu, iconv, this.width, this.height);

			GL11.glPopMatrix();
			GL11.glPushMatrix();
			GL11.glTranslatef(this.xPosition, this.yPosition, 0);
			this.drawCenteredString(fontrenderer, message, (int) (this.width / 2 * GuiStats.SCALE), (int) (this.height * GuiStats.SCALE) + 2, messageColor);
			GL11.glPopMatrix();
		}
	}

	public boolean isUnderMouse(int mouseX, int mouseY)
	{
		return mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width * GuiStats.SCALE && mouseY < this.yPosition + this.height * GuiStats.SCALE;
	}

	@Override
	public boolean mousePressed(Minecraft par1Minecraft, int mouseX, int mouseY)
	{
		return this.enabled && this.drawButton && mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width * GuiStats.SCALE && mouseY < this.yPosition + this.height * GuiStats.SCALE;
	}

	public String getHoverMessage(int which)
	{
		if (which == 0)
		{
			return stat.name + " L" + stat.getPlayersStatLevel(player);
		} else
		{
			return stat.getAppliedDescriptionString(player);
		}
	}

}
