package goki.stats.client.gui;

import goki.stats.stats.Stat;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Gui;
import net.minecraft.entity.player.EntityPlayer;

public class GuiStatTooltip extends Gui
{
	private Stat stat;
	private EntityPlayer player;
	private Minecraft mc = Minecraft.getMinecraft();
	private int padding = 4;

	public GuiStatTooltip(Stat stat, EntityPlayer player)
	{
		this.stat = stat;
		this.player = player;
	}

	public void draw(int drawX, int drawY, int mouseButton)
	{
		int level = stat.getPlayersStatLevel(player);
		String header = stat.name + " L" + level;
		String message = stat.getAppliedDescriptionString(player);
		String cost = "Costs " + stat.getCost(level) + "xp";
		if (level >= stat.getLimit())
			cost = "Maxed!";
		int width = Math.max(mc.fontRenderer.getStringWidth(message), mc.fontRenderer.getStringWidth(header)) + padding * 2;
		int height = mc.fontRenderer.FONT_HEIGHT * 3 + padding * 2;
		int h = height / 3;
		int x = drawX - width / 2;
		int y = drawY;
		int leftEdge = 0;
		int left = x;
		if (left < leftEdge)
		{
			x -= leftEdge - left + 1;
		}
		int rightEdge = mc.currentScreen.width;
		int right = x + width;
		if (right > rightEdge)
		{
			x += rightEdge - right - 1;
		}
		drawRect(x, y, x + width, y - height, 0xCC000000);
		drawString(mc.fontRenderer, header, x + padding / 2, y - h * 3 + padding / 2, 0xFFFFCC00);
		drawString(mc.fontRenderer, message, x + padding / 2, y - h * 2 + padding / 2, 0xFFFFFFFF);
		drawString(mc.fontRenderer, cost, x + padding / 2, y - h + padding / 2, 0xFF00CCFF);
		drawBorder(x, y, width, height, 0xFFFFFFFF);
	}

	private void drawBorder(int x, int y, int width, int height, int borderColor)
	{
		drawHorizontalLine(x - 1, x + width, y, borderColor);
		drawHorizontalLine(x - 1, x + width, y - height, borderColor);
		drawVerticalLine(x - 1, y, y - height, borderColor);
		drawVerticalLine(x + width, y, y - height, borderColor);
	}
}
