package goki.stats.handlers;

import goki.stats.GokiStats;
import goki.stats.client.gui.GuiInfo;

import java.util.EnumSet;

import net.minecraft.entity.player.EntityPlayer;
import cpw.mods.fml.common.ITickHandler;
import cpw.mods.fml.common.TickType;

public class ClientPlayerTickHandler implements ITickHandler
{
	private final EnumSet<TickType> ticksToGet;

	public ClientPlayerTickHandler(EnumSet<TickType> ticksToGet)
	{
		this.ticksToGet = ticksToGet;
	}

	@Override
	public EnumSet<TickType> ticks()
	{
		return ticksToGet;
	}

	@Override
	public String getLabel()
	{
		return "gokiStatsTick";
	}

	public static void playerTick(EntityPlayer player)
	{
		if (GokiKeyHandler.statsMenu.isPressed())
		{
			player.openGui(GokiStats.instance, GuiInfo.STATS_SCREEN_ID, player.worldObj, (int) player.posX, (int) player.posY, (int) player.posZ);
		} else if (GokiKeyHandler.compatibilityMenu.isPressed())
		{
			player.openGui(GokiStats.instance, GuiInfo.COMPATIBILITY_SCREEN_ID, player.worldObj, (int) player.posX, (int) player.posY, (int) player.posZ);
		}
	}

	@Override
	public void tickStart(EnumSet<TickType> type, Object... tickData)
	{
		playerTick((EntityPlayer) tickData[0]);
	}

	@Override
	public void tickEnd(EnumSet<TickType> type, Object... tickData)
	{
	}
}