package goki.stats.handlers;

import goki.stats.stats.Stat;

import java.util.EnumSet;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ContainerFurnace;
import net.minecraft.tileentity.TileEntityFurnace;
import cpw.mods.fml.common.ITickHandler;
import cpw.mods.fml.common.TickType;

public class ServerPlayerTickHandler implements ITickHandler
{
	private final EnumSet<TickType> ticksToGet;

	public ServerPlayerTickHandler(EnumSet<TickType> ticksToGet)
	{
		this.ticksToGet = ticksToGet;
	}

	@Override
	public EnumSet<TickType> ticks()
	{
		return ticksToGet;
	}

	@Override
	public String getLabel()
	{
		return "GokiServerPlayerTick";
	}

	public static void playerTick(EntityPlayer player)
	{
		if (Stat.STAT_FURNACE_FINESSE.getPlayersStatLevel(player) > 0 && player.openContainer instanceof ContainerFurnace)
		{
			int tickBonus = (int) Stat.STAT_FURNACE_FINESSE.getBonus(player);
			float timeBonus = (int) Stat.STAT_FURNACE_FINESSE.getSecondaryBonus(player);
			TileEntityFurnace furnace = ((ContainerFurnace) player.openContainer).furnace;
			if (furnace != null && furnace.isBurning() && furnace.canSmelt())
			{
				if (furnace.furnaceCookTime < 200)
				{
					if (player.getRNG().nextInt(100) < timeBonus)
					{
						furnace.furnaceCookTime += tickBonus;
					}
				} else
				{
					furnace.furnaceCookTime = 199;
				}
			}
		}
	}

	@Override
	public void tickStart(EnumSet<TickType> type, Object... tickData)
	{

	}

	@Override
	public void tickEnd(EnumSet<TickType> type, Object... tickData)
	{
		playerTick((EntityPlayer) tickData[0]);
	}
}