package goki.stats.lib;

public class TreasureFinderEntry
{

	public int blockID = 0;
	public int blockMD = 0;
	public int itemID = 0;
	public int itemMD = 0;
	public int miniumLevel = 0;
	public int chance = 0; // 0-10000

	public TreasureFinderEntry(int bID, int bMD, int iID, int iMD, int mL, int c)
	{
		blockID = bID;
		blockMD = bMD;
		itemID = iID;
		itemMD = iMD;
		miniumLevel = mL;
		chance = c;
	}

	public TreasureFinderEntry(String configString)
	{
		fromConfigurationString(configString);
	}

	public String toConfigurationString()
	{
		return blockID + "_" + blockMD + "_" + itemID + "_" + itemMD + "_" + miniumLevel + "_" + chance;

	}

	public boolean fromConfigurationString(String configString)
	{
		boolean successful = false;
		try
		{
			String[] values = configString.split("_");
			blockID = Integer.parseInt(values[0]);
			blockMD = Integer.parseInt(values[1]);
			itemID = Integer.parseInt(values[2]);
			itemMD = Integer.parseInt(values[3]);
			miniumLevel = Integer.parseInt(values[4]);
			chance = Integer.parseInt(values[5]);
		} catch (Exception e)
		{
			successful = false;
		}
		return successful;
	}

}
