package goki.stats.stats;

import goki.stats.ToolSpecificStat;
import goki.stats.lib.Helper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;

public class StatBowmanship extends ToolSpecificStat
{
	public StatBowmanship(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public String getConfigurationKey()
	{
		return "Bowmanship Tools";
	}

	@Override
	public float getBonus(int level)
	{
		return getFinalBonus((float) Math.pow(level, 1.0895) * 0.03f);
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{

		return "Deal " + Helper.trimDecimals(getBonus(getPlayersStatLevel(player)) * 100, 1) + "% more damage with a bow.";
	}

	@Override
	public String[] getDefaultSupportedItems()
	{
		return new String[]
		{ Item.bow.itemID + ":0" };
	}

}
