package goki.stats.stats;

import goki.stats.ToolSpecificStat;
import goki.stats.lib.Helper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;

public class StatChopping extends ToolSpecificStat
{

	public StatChopping(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public String getConfigurationKey()
	{
		return "Chopping Tools";
	}

	@Override
	public float getBonus(int level)
	{
		return Stat.getFinalBonus((float) Math.pow(level, 1.3) * 0.01523f);
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{
		return "Chop " + Helper.trimDecimals(getBonus(getPlayersStatLevel(player)) * 100, 1) + "% faster.";
	}

	@Override
	public String[] getDefaultSupportedItems()
	{
		return new String[]
		{ Item.axeWood.itemID + ":0", Item.axeStone.itemID + ":0", Item.axeIron.itemID + ":0", Item.axeGold.itemID + ":0", Item.axeDiamond.itemID + ":0" };

	}

}
