package goki.stats.stats;

import goki.stats.ToolSpecificStat;
import goki.stats.lib.Helper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;

public class StatDigging extends ToolSpecificStat
{
	public StatDigging(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public String getConfigurationKey()
	{
		return "Digging Tools";
	}

	@Override
	public float getBonus(int level)
	{
		return Stat.getFinalBonus((float) Math.pow(level, 1.3) * 0.01523f);
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{
		return "Dig " + Helper.trimDecimals(getBonus(getPlayersStatLevel(player)) * 100, 1) + "% faster.";
	}

	@Override
	public String[] getDefaultSupportedItems()
	{
		return new String[]
		{ Item.shovelWood.itemID + ":0", Item.shovelStone.itemID + ":0", Item.shovelIron.itemID + ":0", Item.shovelGold.itemID + ":0", Item.shovelDiamond.itemID + ":0" };
	}

}
