package goki.stats.stats;

import goki.stats.DamageSourceProtectionStat;
import goki.stats.lib.Helper;
import net.minecraft.entity.player.EntityPlayer;

public class StatFeatherFall extends DamageSourceProtectionStat
{

	public StatFeatherFall(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public float getBonus(int level)
	{
		return getFinalBonus(level * 0.026f);
	}

	@Override
	public float getSecondaryBonus(int level)
	{
		return getFinalBonus(level * 0.1f);
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{
		float height = Helper.getFallResistance(player) + Helper.trimDecimals(getSecondaryBonus(getPlayersStatLevel(player)), 1);
		return "Take " + Helper.trimDecimals(getBonus(getPlayersStatLevel(player)) * 100, 1) + "% less damage from falling more than " + height + " blocks.";
	}

	@Override
	public String[] getDefaultDamageSources()
	{
		return new String[]
		{ "fall" };
	}

}
