package goki.stats.stats;

import goki.stats.lib.Helper;
import net.minecraft.entity.player.EntityPlayer;

public abstract class StatLeaper extends Stat
{

	public StatLeaper(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public float getBonus(int level)
	{
		return getFinalBonus((float) Math.pow(level, 1.065) * 0.0195f);
	}

	@Override
	public float getSecondaryBonus(int level)
	{
		return getFinalBonus((float) Math.pow(level, 1.1) * 0.0203f);
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{
		return "Jump " + Helper.trimDecimals(getBonus(getPlayersStatLevel(player)) * 100, 1) + "% higher and " + Helper.trimDecimals(getSecondaryBonus(getPlayersStatLevel(player)) * 100, 1) + "% farther when sprinting.";
	}
}
