package goki.stats.stats;

import goki.stats.ToolSpecificStat;
import goki.stats.lib.Helper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;

public class StatMining extends ToolSpecificStat
{

	public StatMining(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public String getConfigurationKey()
	{
		return "Mining Tools";
	}

	@Override
	public float getBonus(int level)
	{
		return getFinalBonus((float) Math.pow(level, 1.3) * 0.01523f);
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{
		return "Mine " + Helper.trimDecimals(getBonus(getPlayersStatLevel(player)) * 100, 1) + "% faster.";
	}

	@Override
	public String[] getDefaultSupportedItems()
	{
		return new String[]
		{ Item.pickaxeWood.itemID + ":0", Item.pickaxeStone.itemID + ":0", Item.pickaxeIron.itemID + ":0", Item.pickaxeGold.itemID + ":0", Item.pickaxeDiamond.itemID + ":0" };
	}
}
