package goki.stats.stats;

import goki.stats.lib.Helper;
import goki.stats.lib.Reference;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.common.Configuration;

public class StatReaper extends Stat
{

	public static float healthLimit = 20.0f;

	public StatReaper(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public float getBonus(int level)
	{
		return getFinalBonus((float) Math.pow(level, 1.0768) * 0.0025f);
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{
		return Helper.trimDecimals(getBonus(getPlayersStatLevel(player)) * 100, 1) + "% chance to instantly kill enemies with less than " + healthLimit + " health.";
	}

	@Override
	public int isAffectedByStat(Object object)
	{
		if (object != null)
		{
			if (!(object instanceof EntityPlayer))
			{
				if (object instanceof EntityLivingBase)
				{
					EntityLivingBase target = (EntityLivingBase) object;
					if (target.getMaxHealth() <= healthLimit)
					{
						return 1;
					}
				}
			}
		}
		return 0;
	}

	@Override
	public void loadFromConfigurationFile(Configuration config)
	{
		healthLimit = (float) Reference.configuration.get("Support", "Reaper Limit", healthLimit).getDouble(20.0);
	}

	@Override
	public void saveToConfigurationFile(Configuration config)
	{
		Reference.configuration.get("Support", "Reaper Limit", healthLimit).set(healthLimit);
	}

	@Override
	public String toConfigurationString()
	{
		return "" + healthLimit;
	}

	@Override
	public void fromConfigurationString(String configString)
	{
		try
		{
			healthLimit = Float.parseFloat(configString);
		} catch (Exception e)
		{

		}
	}

}
