package goki.stats.stats;

import goki.stats.lib.Helper;
import net.minecraft.entity.player.EntityPlayer;

public class StatStealth extends StatLeaper
{

	public StatStealth(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public float getBonus(int level)
	{
		return getFinalBonus((float) Math.pow(level, 1.3416));
	}

	@Override
	public int isAffectedByStat(Object object)
	{
		if (object instanceof EntityPlayer && ((EntityPlayer) object).isSneaking())
		{
			return 1;
		}
		return 0;
	}

	@Override
	public float getSecondaryBonus(int level)
	{
		return getFinalBonus((float) Math.pow(level, 1.4307));
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{
		float speed = Helper.trimDecimals(getBonus(player), 1);
		float reapBonus = Helper.trimDecimals(getSecondaryBonus(player), 1);
		float reap = Stat.STAT_REAPER.getBonus(player) * 100;
		float newReap = Helper.trimDecimals(reap + reap * reapBonus / 100, 1);
		return "Move " + speed + "% faster and reap " + reapBonus + "% more often (" + newReap + "%) when sneaking.";
	}
}
