package goki.stats.stats;

import goki.stats.ToolSpecificStat;
import goki.stats.lib.Helper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;

public class StatSwordsmanship extends ToolSpecificStat
{
	public StatSwordsmanship(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public String getConfigurationKey()
	{
		return "Swordsmanship Tools";
	}

	@Override
	public float getBonus(int level)
	{
		return getFinalBonus((float) Math.pow(level, 1.0895) * 0.03f);
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{
		return "Deal " + Helper.trimDecimals(getBonus(getPlayersStatLevel(player)) * 100, 1) + "% more damage with swords.";
	}

	@Override
	public String[] getDefaultSupportedItems()
	{
		return new String[]
		{ Item.swordWood.itemID + ":0", Item.swordStone.itemID + ":0", Item.swordIron.itemID + ":0", Item.swordGold.itemID + ":0", Item.swordDiamond.itemID + ":0" };
	}

}
