package goki.stats.stats;

import goki.stats.lib.TreasureFinderEntry;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.Configuration;

public class StatTreasureFinder extends Stat
{

	public static List<TreasureFinderEntry> entries = new ArrayList<TreasureFinderEntry>();
	// @formatter:off
	public static String[] defaultEntries = new String[]{
		new TreasureFinderEntry(Block.sand.blockID, 0, Item.goldNugget.itemID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.rottenFlesh.itemID, 0, 1, 40).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.bone.itemID, 0, 1, 20).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.spiderEye.itemID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.gunpowder.itemID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.slimeBall.itemID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(Block.sand.blockID, 0, Item.glassBottle.itemID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(Block.sand.blockID, 0, Item.pocketSundial.itemID, 0, 1, 5).toConfigurationString(),
		new TreasureFinderEntry(Block.sand.blockID, 0, Item.compass.itemID, 0, 1, 5).toConfigurationString(),
		new TreasureFinderEntry(Block.sand.blockID, 0, Item.clay.itemID, 0, 1, 20).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.bowlEmpty.itemID, 0, 1, 6).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.potato.itemID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.carrot.itemID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.appleRed.itemID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Block.mushroomRed.blockID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Block.mushroomBrown.blockID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Block.plantRed.blockID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Block.plantYellow.blockID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.appleRed.itemID, 0, 1, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.stick.itemID, 0, 1, 100).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.pumpkinSeeds.itemID, 0, 1, 30).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.melonSeeds.itemID, 0, 1, 30).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.beefRaw.itemID, 0, 2, 50).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.porkRaw.itemID, 0, 2, 50).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.chickenRaw.itemID, 0, 2, 50).toConfigurationString(),
		new TreasureFinderEntry(Block.sand.blockID, 0, Item.ingotIron.itemID, 0, 2, 10).toConfigurationString(),
		new TreasureFinderEntry(Block.sand.blockID, 0, Item.ingotGold.itemID, 0, 2, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.leather.itemID, 0, 2, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.feather.itemID, 0, 2, 10).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Block.cloth.blockID, 0, 2, 10).toConfigurationString(),
		new TreasureFinderEntry(Block.sand.blockID, 0, Item.redstone.itemID, 0, 2, 50).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.bucketEmpty.itemID, 0, 3, 20).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.record11.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.record13.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordBlocks.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordCat.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordChirp.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordFar.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordMall.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordMellohi.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordStal.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordStrad.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordWait.itemID, 0, 3, 2).toConfigurationString(),
		new TreasureFinderEntry(-1, 0, Item.recordWard.itemID, 0, 3, 2).toConfigurationString()
		};
	// @formatter:on

	public StatTreasureFinder(int id, String key, String name, int limit)
	{
		super(id, key, name, limit);
	}

	@Override
	public String getAppliedDescriptionString(EntityPlayer player)
	{
		if (getPlayersStatLevel(player) == 0)
		{
			return "Chance to find additional items when harvesting blocks.";
		}
		return "Chance to find more rare additional items when harvesting blocks.";
	}

	@Override
	public void loadFromConfigurationFile(Configuration config)
	{
		entries.clear();
		String[] entryStrings = config.get("Treasure Finder", "Entries", defaultEntries).getStringList();
		for (int i = 0; i < entryStrings.length; i++)
		{
			entries.add(new TreasureFinderEntry(entryStrings[i]));
		}
	}

	@Override
	public void saveToConfigurationFile(Configuration config)
	{
		String[] entryStrings = new String[entries.size()];
		for (int i = 0; i < entryStrings.length; i++)
		{
			entryStrings[i] = entries.get(i).toConfigurationString();
		}
		config.get("Treasure Finder", "Entries", defaultEntries).set(entryStrings);
	}

	public List<ItemStack> getApplicableItemStackList(int blockID, int blockMD, int level)
	{
		List<ItemStack> items = new ArrayList<ItemStack>();
		for (TreasureFinderEntry tfe : entries)
		{
			if (tfe.miniumLevel <= level)
			{
				if ((tfe.blockID == -1 && (blockID == Block.dirt.blockID || blockID == Block.grass.blockID)) || tfe.blockID == blockID && tfe.blockMD == blockMD)
				{
					items.add(new ItemStack(tfe.itemID, 1, tfe.itemMD));
				}
			}
		}
		return items;
	}

	public List<Integer> getApplicableChanceList(int blockID, int blockMD, int level)
	{
		List<Integer> chance = new ArrayList<Integer>();
		for (TreasureFinderEntry tfe : entries)
		{
			if (tfe.miniumLevel <= level)
			{
				if ((tfe.blockID == -1 && (blockID == Block.dirt.blockID || blockID == Block.grass.blockID)) || tfe.blockID == blockID && tfe.blockMD == blockMD)
				{
					chance.add(tfe.chance);
				}
			}
		}
		return chance;
	}

	@Override
	public String toConfigurationString()
	{
		String configString = "";
		for (int i = 0; i < entries.size(); i++)
		{
			configString += "," + entries.get(i).toConfigurationString();
		}
		return configString;
	}

	@Override
	public void fromConfigurationString(String configString)
	{
		entries.clear();
		String[] configStringSplit = configString.split(",");
		for (int i = 0; i < configStringSplit.length; i++)
		{
			entries.add(new TreasureFinderEntry(configStringSplit[i]));
		}
	}

	@Override
	public int getCost(int level)
	{
		int cost = 170;
		if (level == 1)
		{
			cost = 370;
		} else if (level == 2)
		{
			cost = 820;
		}
		return cost;
	}

	@Override
	public int getLimit()
	{
		return 3;
	}
}
